<?php

defined( 'ABSPATH' ) || exit();

/**
 * Bikys_Megamenu_Walker
 *
 * extends Walker_Nav_Menu
 */
class Bikys_Admin_Megamenu_Assets {

	public static function init() {
		add_action( 'admin_enqueue_scripts', array( __CLASS__, 'enqueue_scripts' ) );
		add_action( 'elementor/editor/after_enqueue_scripts', array( __CLASS__, 'add_scripts_editor' ) );
	}

	public static function add_scripts_editor() {
		global $bikys_version;
		if ( isset( $_REQUEST['bikys-menu-editable'] ) && $_REQUEST['bikys-menu-editable'] ) {
			wp_register_script( 'bikys-elementor-menu', get_template_directory_uri() . '/inc/megamenu/assets/js/editor.js', [], $bikys_version );
			wp_enqueue_script( 'bikys-elementor-menu' );
		}
	}

	/**
	 * enqueue scripts
	 */
	public static function enqueue_scripts( $page ) {
		global $bikys_version;
		if ( $page === 'nav-menus.php' ) {
			wp_enqueue_script( 'backbone' );
			wp_enqueue_script( 'underscore' );

			$suffix = '.min';
			wp_register_script(
				'jquery-elementor-select2',
				ELEMENTOR_ASSETS_URL . 'lib/e-select2/js/e-select2.full' . $suffix . '.js',
				[
					'jquery',
				],
				'4.0.6-rc.1',
				true
			);
			wp_enqueue_script( 'jquery-elementor-select2' );
			wp_register_style(
				'elementor-select2',
				ELEMENTOR_ASSETS_URL . 'lib/e-select2/css/e-select2' . $suffix . '.css',
				[],
				'4.0.6-rc.1'
			);
			wp_enqueue_style( 'elementor-select2' );
			wp_enqueue_style( 'wp-color-picker' );
			wp_enqueue_script( 'wp-color-picker' );
			wp_register_script( 'bikys-megamenu', get_template_directory_uri() . '/inc/megamenu/assets/js/admin.js', array(
				'jquery',
				'backbone',
				'underscore'
			), $bikys_version, true );
			wp_localize_script( 'bikys-megamenu', 'bikys_memgamnu_params', apply_filters( 'bikys_admin_megamenu_localize_scripts', array(
				'ajaxurl' => admin_url( 'admin-ajax.php' ),
				'i18n'    => array(
					'close' => esc_html__( 'Close', 'bikys' ),
					'submit' => esc_html__( 'Save', 'bikys' )
				),
				'nonces'  => array(
					'load_menu_data' => wp_create_nonce( 'bikys-menu-data-nonce' )
				)
			) ) );
			wp_enqueue_script( 'bikys-megamenu' );

			wp_enqueue_style( 'bikys-megamenu', get_template_directory_uri() . '/inc/megamenu/assets/css/admin.css', [], $bikys_version );
			wp_enqueue_style( 'bikys-elementor-custom-icon', get_theme_file_uri( '/assets/css/admin/elementor/icons.css' ), [], $bikys_version );
		}

	}

}

Bikys_Admin_Megamenu_Assets::init();
